# -*- coding: utf-8 -*-
"""
Created on Tue Oct 19 16:18:13 2021

@author: simsh
"""

#!/usr/bin/python3

import os.path
from multiprocessing.pool import ThreadPool
import sys
import multiprocessing as mp

import rtasConstants as constants
from dagTask import dagTask
import makePairs as ILP
from random import uniform
import math


outputFile="10-27-chosenBigDAGs-randomUtil.csv"
fedOutputFile="02-09-fedSched.csv"


#How to optimize performance?
#I get ten nodes at a time.
#Save the giant DAGs for last.
#Priority: get some complete scenarios.
#Start with the easiest cases: low subtask count, high p.
#Write the graph code so that problems can be found early.
#Six graphs per page, each page gives one count+prob combo?
#Then each run will produce one page of graphs.

#Today: get the new batch running; write graph code.

INFINITY=float('inf')
BASE=0
SMT=1

#maxDist=10
#maxSol=10
#numLayers=4

'''
count=int(sys.argv[1])
#prob=float(sys.argv[2])
maxDist=int(sys.argv[2])
maxSol=int(sys.argv[3])
numLayers=int(sys.argv[4]) #set to 0 to keep using Erdos-Renyi
PROB_LIST=[float(sys.argv[5])]
UTIL_LIST=[int(sys.argv[6])]
SMT_LIST=[int(sys.argv[7])]
'''


#dagsPerScenario=25
#deadlinesPerDag=1

#what can Gurobi use per DAG?
maxThreads=1


mode=sys.argv[1]
outputFile=sys.argv[2]


#count=10
#PROB_LIST=[0.1, 0.3, 0.5, 0.7, 0.9, 1]

count=int(sys.argv[3])
numLayers=int(sys.argv[4])
prob=float(sys.argv[5])
dagWeight=sys.argv[6]
#Testing parameters

#count=10
#numLayers=2
#prob=.5
maxDist=10
maxSol=10
#UTIL_LIST=[constants.NARROW]
#SMT_LIST=[constants.OPTIMIST]
#DAG_WEIGHTS=["heavy"]
#numLayers=2
UTIL_LIST=[constants.NARROW, constants.WIDE]
SMT_LIST=[constants.OPTIMIST, constants.OK, constants.PESSIMIST]
PROB_LIST=[-0.1, 0.3, 0.5, 0.7, 1]
#DAG_WEIGHTS=["light", "medLight", "medHeavy", "heavy"]



dagsPerScenario=5
systemsPerCount=10
deadlinesPerDag=1


#utilStep=0.25

fConfigurations=[]

for util in UTIL_LIST:
    for smt in SMT_LIST:
        for i in range(1, systemsPerCount+1):
            fConfig={}
            fConfig["c"]=count #command line
            fConfig["u"]=util
            fConfig["s"]=smt
            fConfig["p"]=prob
            fConfig["systemsPerCount"]=i
            fConfig["nL"]=numLayers #command line
            fConfig["dagWeight"]=dagWeight
            fConfigurations.append(fConfig)


sConfigurations=[]

#generate numLayers based on Count
for layer in [2, 4, 8, 16]:
    if count / layers >=5:
        layerList.append(layer)
        
#pick the probabilities to use based on numLayers
        

for util in UTIL_LIST:
    for smt in SMT_LIST:
        for i in range(systemsPerCount):
            for prob in PROB_LIST:
                sConfig={}
                sConfig["c"]=count
                sConfig["u"]=util
                sConfig["s"]=smt
                sConfig["p"]=prob
                sConfig["i"]=len(configurations)+i
                sConfig["nL"]=numLayers
                configurations.append(sConfig)
              
SYNC = False


#the input to run_test, 'config', is one of the many dictionaries contained in the list 'configurations'
def parallelSingleDag(sConfig):
    #the '**' notation indicates that dictionary config is to be treated as a set of keyword arguments
    runDagFamily(**sConfig)


def parallelFedSched(fconfig):
    #the '**' notation indicates that dictionary config is to be treated as a set of keyword arguments
    fedSched(**fConfig)
    

def fedSched(u, s, p, c, systemsPerCount, nL, dagWeight):
    
    '''
    When using the parallelFedSched method to run, setting systemsPerCount>1
    will create multiple systems for each number of DAGs.    
    '''
    
    numSystems=1
    
    #imagine a 16 core system
    #max baseline util approx 32
    
    if dagWeight=="light":
        '''
        0.5, 1 gives mean 0.75
        32/0.75=42.67
        '''
        minDags=1
        maxDags=43
    
    elif dagWeight=="medLight":
        '''
        U(1,2) gives mean 1.5
        32/1.5=21.33
        '''
        maxDags=22
        minDags=1
        
    elif dagWeight=="medHeavy":
        '''
        U(2, 4) gives mean 3
        32/3=10.66
        '''
        maxDags=11
        minDags=1
        
    elif dagWeight=="heavy":
        '''
        U(4,8) gives mean 6
        32/6=5.33
        '''
        maxDags=5
        minDags=1
    
    for numDags in range(minDags, maxDags+1):
        for j in range(numSystems):
            utilList=[[],[]]
            coreList=[[],[]]
            
            heavyCores=[0,0]
            lightCores=[0,0]
            totalCores=[0,0]
            lightUtilList=[[],[]]
            #create individual DAGs
            
            for k in range(numDags):
                #TO-DO: add utilization options to runDagFamily
                
                #start by running just one dagWeight at a time
                
                (baseUtil, smtUtil, baseCores, smtCores)=runDagFamily(u, s, p, c, -1, nL, dagWeight)
                utilList[BASE].append(baseUtil)
                utilList[SMT].append(smtUtil)
                coreList[BASE].append(baseCores)
                coreList[SMT].append(smtCores)
                
                for x in (BASE, SMT):
                    if utilList[x][k]>=1:
                        heavyCores[x]=heavyCores[x]+coreList[x][k]
                    else:
                        lightUtilList[x].append(utilList[x][k])
                
            #end of for k in range (i)
            #all the Dags have been created
            for x in (BASE, SMT):  
                    lightCores[x]=min(bestFit(lightUtilList[x]), worstFit(lightUtilList[x]))
                    totalCores[x]=lightCores[x]+heavyCores[x]
            
            #print(
            #        sum(utilList[BASE]), sum(utilList[SMT]), totalCores[BASE], totalCores[SMT])
            
            #what do I need to record?
            #Dag parameters, number of dags, four summary stats
            
            #i gives number of tasks in current system

            scenarioList=[str(u), str(s), str(p), str(c), str(maxDist), str(maxSol), str(nL), dagWeight]
            scenarioString=','.join(scenarioList)
            
            resultString=(scenarioString +  
             ',' + str(numDags) +
             ',' + str(sum(utilList[BASE])) +
             ',' + str(sum(utilList[SMT])) + 
             ',' + str(totalCores[BASE]) +
             ',' + str(totalCores[SMT])
             )
             
            with open(fedOutputFile, "a") as f:
                 print(resultString, file=f)

            
            
        # end of for j in range(numSystems); move on to next system    
    #end of for i in range (minDAGs, maxDAGs); make systems with more DAGs
    

def bestFit(utilList):
    #put tasks onto the core that will minimize the remaining space
    coresAttempted=math.ceil(sum(utilList))
    utilList.sort(reverse=True)
    coreList=[0]*coresAttempted
    while True:
        for u in utilList:
            bestUtil=0
            bestCore=-1
            for c in range(coresAttempted):
                if u+coreList[c] <=1 and coreList[c]>=bestUtil:
                    bestCore=c
            #end of for c in coreList
            if bestCore==-1:
                coresAttempted+=1
                break
            else:
                coreList[bestCore]=coreList[bestCore]+u    
        #end of for u in utilList
        return coresAttempted       
    #end of while True
    
    
def worstFit(utilList):
    #put tasks onto the core that will maximize the remaining space
    coresAttempted=math.ceil(sum(utilList))
    utilList.sort(reverse=True)
    coreList=[0]*coresAttempted
    while True:
        for u in utilList:
            bestUtil=1
            bestCore=-1
            for c in range(coresAttempted):
                if u+coreList[c] <=1 and coreList[c]<=bestUtil:
                    bestCore=c
            #end of for c in coreList
            if bestCore==-1:
                coresAttempted+=1
                break
            else:
                coreList[bestCore]=coreList[bestCore]+u    
        #end of for u in utilList
        return coresAttempted       
    #end of while True
        
    

def runDagFamily(u, s, p, c, i, nL, dagWeight="default"):           
    scenarioList=[str(u), str(s), str(p), str(c), str(maxDist), str(maxSol)]
    scenarioString=','.join(scenarioList)
    myDAG=dagTask(fileName="random", targetNodeCount=c, targetCost=0, 
  nodeUtilDist=u, smtDist=s, erdoRenyiP=p, numLayers=numLayers)

    minDeadline=myDAG.length    # util>1, but hard to know by how much

    
    maxUtil=myDAG.totalCost/myDAG.length
    
    
    #TO-DO: allow more options on this line
    if dagWeight=="light":
        #expect good performance; core reduction should track util reduction
        minUtil=min(0.5, maxUtil)
        maxUtil=min(1, maxUtil)
    elif dagWeight=="medLight":
        #core reduction better than util reduction?
        minUtil=min(1, maxUtil)
        maxUtil=min(2, maxUtil)
        
    elif dagWeight=="medHeavy":
        #expect poor performance; core reduction unlikely to track
        minUtil=min(2, maxUtil)
        maxUtil=min(4, maxUtil)
    elif dagWeight=="heavy":
        #expect good performance
        minUtil=min(4, maxUtil)
        maxUtil=min(8, maxUtil)    
    else:
        # in use for single DAGs, not fedSched
        minUtil=1
    baseUtil=uniform(minUtil, maxUtil)
    deadline=myDAG.totalCost/baseUtil

    myDAG.deadline=deadline
    
    #schedule without SMT and record cores
    myDAG.makeBaselinePairList();
    baseCost=myDAG.totalCost
    #baseUtil=myDAG.totalCost/deadline
    baseCores=myDAG.howManyCores()
    

    pairs=ILP.makePairs(myDAG)
    #set max solutions, maxDistance
    pairs.setSolverParams(maxThreads, maxSol, maxDist)
    pairs.createSchedVars()

    baselineString=(scenarioString +
                ',' + str(i) +
                ',' + str(deadline) +
                 ',' + str(myDAG.length) +
                 ',' + str(baseCost) +
                 ',' + str(baseUtil) + 
                 ',' + str(baseCores))
    pairs.solver.optimize()
    #solver time
    solverTime=pairs.solver.runtime
    #optimal? gap?
    #optimal=pairs.solver.OPTIMAL
    #smt cost
    smtCost=pairs.varTotalCost.x
    #smt util
    smtUtil=smtCost/deadline
    #smt cores
    myDAG.makeSmtPairList(pairs.getPairList())
    smtCores=myDAG.howManyCores()
    
    smtString=(baselineString +
               ',' + str(solverTime) +
               #',' + str(gap) +
               ',' + str(smtCost) +
               ',' + str(smtUtil) +
               ',' + str(smtUtil/baseUtil) +
               ',' + str(smtCores) +
               ',' + str(smtCores/baseCores) +
               ',' + str(pairs.solver.SolCount) +
               ',' + str(pairs.solver.MIPGap) +
               ',' + str(numLayers)
               )
    
    if sys.argv[1]=="single":
        #we're done; output results
        with open(outputFile, "a") as f:
            print(smtString, file=f)
    else:
        #using fedSched, return result for additional processing.    
        return (baseUtil, smtUtil, baseCores, smtCores)


if __name__ == '__main__':
    #print headers
    '''
    with open(outputFile, "a") as f:
        print("utilDist", "smtDist", "Prob", "nodeCount",
          "maxDist", "maxSol",
          "dagFamilyID",
          "deadline", "length", "baseCost", "baseUtil", "baseCores",
          "solverTime", "smtCost", "smtUtil", "smtUtil/base",
          "smtCores", "smtCores/base",
          "solutionsFound", "optimalGap",
          "numLayers",
          sep=",", file=f)
'''        

    
    if sys.argv[1]=="fed":
            #print headers
            with ThreadPool(processes=mp.cpu_count()) as pool:
            for res_tup in pool.imap_unordered(parallelFedSched, fConfigurations):
                pass
    elif sys.argv[1]=="single":
        with open(sys.argv[2], "a") as f:
            print("utilDist", "smtDist", "Prob", "nodeCount",
              "maxDist", "maxSol",
              "dagFamilyID",
              "deadline", "length", "baseCost", "baseUtil", "baseCores",
              "solverTime", "smtCost", "smtUtil", "smtUtil/base",
              "smtCores", "smtCores/base",
              "solutionsFound", "optimalGap",
              "numLayers",
              sep=",", file=f)
        with ThreadPool(processes=mp.cpu_count()) as pool:
            for res_tup in pool.imap_unordered(parallelSingleDag, sConfigurations):
                pass
    
    
    

